from tkinter import *
import math,time
#■初期設定
NumX = 50; NumY = 50
Z=[[0 for j in range(NumY + 1)] for i in range(NumX + 1)]
ID=[[0 for j in range(NumY + 1)] for i in range(NumX + 1)]
ZX=[[0 for j in range(NumY + 1)] for i in range(NumX + 1)]
ZY=[[0 for j in range(NumY + 1)] for i in range(NumX + 1)]
def initHidden():
    XY=[[0,0] for i in range(4)]
    XY[0][0]=200;XY[0][1]=200; XY[1][0]=200;XY[1][1]=210
    XY[2][0]=210;XY[2][1]=210; XY[3][0]=210;XY[3][1]=200
    A=math.pi/9; B=math.pi/6; DX=5
    cosA=DX*math.cos(A);cosB=DX*math.cos(B)
    sinA=DX*math.sin(A);sinB=DX*math.sin(B)
    for i in range(NumX+1):
        for j in range(NumY+1):
            ZX[i][j]=250+(i*cosA-j*cosB)
            ZY[i][j]=250-(i*sinA+j*sinB)
    for i in range(NumX):
        for j in range(NumY):
            ID[i][j]=canvas.create_polygon(XY,fill="white", outline="#000077")
#■隠れ線処理
def hiddenLine(): #　画面の場合のみ可能（プロッタでは使えない）
    global canvas, NumX, NumY
    XY=[0 for i in range(8)]
    for i in range(NumX):
        i2=NumX-i;i1=i2-1
        for j in range(NumY):
            j2=NumX-j; j1=j2-1
            XY[0]=ZX[i1][j1]; XY[1]=ZY[i1][j1]-Z[i1][j1]
            XY[2]=ZX[i1][j2]; XY[3]=ZY[i1][j2]-Z[i1][j2]
            XY[4]=ZX[i2][j2]; XY[5]=ZY[i2][j2]-Z[i2][j2]
            XY[6]=ZX[i2][j1]; XY[7]=ZY[i2][j1]-Z[i2][j1]
            canvas.coords(ID[i][j],XY)
ZS=[[[0 for j in range(NumY+1)] for i in range(NumX+1)] for k in range(2)]
V =[[[0 for j in range(NumY+1)] for i in range(NumX+1)] for k in range(2)]
simTime = 0; ID1 = 0; ID2 = 1; Myu=0.02;counter=0
FreeBoundary=True  # 境界条件を自由端にするときTrueにする
captMode=True      #画面キャプチャするときTrueにする
def setData(): #データを設定
    for j in range(NumX+1):
        for k in range(NumY+1):
            Z[j][k]=80.0*ZS[ID1][j][k]
def initWave():
    global simTime, ID1, ID2, Myu,counter,XS,V
    simTime = 0; ID1 = 0; ID2 = 1; Myu=0.02;counter=0
    for i in range(NumX+1):
        for j in range(NumY+1):
            DX = i - NumX/2; DY = j - NumY/2
            R = math.sqrt(DX * DX + DY * DY)
            if    R < 0.1: A=1
            elif  R > 3  : A=0
            else         : A = math.sin(R) / R;
            ZS[0][ i][ j] = -A;  V[0][ i][ j] = 0;
def waveEquation(SaveN, Alfa, DX, DT):
    global NumX, NumY, ZS, ID1,ID2,simTime,Myu,counter
    Beta = Alfa * Alfa / (DX * DX);
    for k in range(SaveN):
        for i in range(1, NumX):
            for j in range(1, NumY):
                ZS[ID2][i][j] = ZS[ID1][i][j] + DT * V[ID1][i][j]
        for i in range(1, NumX):
            for j in range(1, NumY):
                Acc = Beta * (ZS[ID2][i][j + 1] - 2 * ZS[ID2][i][j] +
                              ZS[ID2][i][j - 1] + ZS[ID2][i + 1][j] -
                              2 * ZS[ID2][i][j] + ZS[ID2][i - 1][j])
                V[ID2][i][j] = V[ID1][i][j] + DT *(Acc- Myu*V[ID1][i][j])
        if FreeBoundary:  #自由端境界条件
            for i in range(NumX+1):
                V [ID2][i][0]    = V [ID2][i][1]
                V [ID2][i][NumY] = V [ID2][i][NumY-1]
                ZS[ID2][i][0]    = ZS[ID2][i][1]
                ZS[ID2][i][NumY] = ZS[ID2][i][NumY-1]
            for i in range(NumY+1):
                V [ID2][0][i]    = V [ID2][1][i]
                V [ID2][NumX][i] = V [ID2][NumX-1][i]
                ZS[ID2][0][i]    = ZS[ID2][1][i]
                ZS[ID2][NumX][i] = ZS[ID2][NumX-1][i]
        else: #固定端境界条件
            for i in range(NumX+1):
                V[ID2][i][0] =0; V[ID2][i][NumY]= 0
                ZS[ID2][i][0]=0; ZS[ID2][i][NumY]=0
            for i in range(NumY+1):
                V[ID2][0][i] =0; V[ID2][NumX][i]=0
                ZS[ID2][0][i]=0; ZS[ID2][NumX][i] = 0
        simTime += DT; ID1 = ID2; ID2 = 1-ID2;counter+=1
    return 0
def leftMouseDown(event):#ダウン
    waveEquation(100, 0.05, 0.05, 0.01)
    setData(); hiddenLine();
    root.title("2次元波動 t = %f" % simTime);root.update()
#■メイン処理
root=Tk();root.title("2次元波動");root.geometry("500x300")
canvas=Canvas(root,width=500,height=300,bg="white"); canvas.pack()
initHidden(); initWave()
if captMode:
    waveEquation(100, 0.05, 0.05, 0.01)
    setData(); hiddenLine();
    root.title("2次元波動 t=%f" % simTime);root.update()
    canvas.bind("<Button-1>",leftMouseDown)
    root.mainloop()
else:
    while(1):
        waveEquation(100, 0.05, 0.05, 0.01)
        setData(); hiddenLine()
        root.title("2次元波動 t = %f" % simTime);root.update()
        time.sleep(0.01)





    
